/** Lot collection aggregate variables **/
var model;
var label;
var indicedebut;
var nbtapes;
var service;
var librairie;
var prix;
var commentaire;
var formInValid;
var commande;
var allTapes;

$(document).ready(function() {

    $('#tableCommandes').DataTable({
        'columnDefs': [ {
            'targets': [3, 4], // column index (start from 0)
            'orderable': false, // set orderable false for selected columns
        }]
    });

    $('body').on('click', '.add_lot', function () {
        var cpt = $(this).attr('id').split("show_");
        $('.' + cpt[1]).removeClass('d-none');
        $('.' + cpt[1]).addClass('active');
    });

    $('body').on('click', '.remove_lot', function () {
        var lotId = $(this).attr('id').split("remove_")[1];

        // Hide fields container
        $('.' + lotId).removeClass('active').addClass('d-none');

        // Remove fields validation control
        $('.' + lotId).find('input').removeClass("is-valid is-invalid");
        $('.' + lotId).find('select').removeClass("is-valid is-invalid");

    });

    $('body').on('click', '.add_lots', function () {
        var cptLot = $(".lots.active").length;

        var idDomForSplit = $(this).attr('id').split("_");
        var idCommand = idDomForSplit[idDomForSplit.length - 1];

        model = [];
        label = [];
        indicedebut = [];
        nbtapes = [];
        service = [];
        librairie = [];
        prix = [];
        commentaire = [];
        formInValid = 0;
        commande = [];
        allTapes = [];

        for (var i = 1; i <= cptLot; i++) {

            var domId = i + '_' + idCommand;

            prepareLotCollection(domId, idCommand);
        }

        var totalTapes = 0;

        for(j = 0; j < allTapes.length; j++)
        {
            totalTapes += Number(allTapes[j]);
        }

        var verif = totalTapes - $('#nbtapes_' + idCommand).val();

        if (verif != 0){
            $('#MessageNbTapes').removeClass('d-none');
        }
        else {
            $('#MessageNbTapes').addClass('d-none');
        }

        if (formInValid == 0 && verif == 0) {

            $.ajax({
                url: '/addLots',
                type: "POST",
                dataType: "json",
                data: {
                    "commande": commande,
                    "model": model,
                    "label": label,
                    "indicedebut": indicedebut,
                    "nbtapes": nbtapes,
                    "service": service,
                    "librairie": librairie,
                    "prix": prix,
                    "commentaire": commentaire
                },
                async: false,
                success: function (data) {
                    $("#addLotModal_" + idCommand).hide();
                    $(".messagedanger").removeClass('d-none');
                    $(".messagedanger").fadeOut(1000);

                    setInterval(function () {
                        location.reload();
                    }, 1000);


                },
                error: function (xhr, textStatus, errorThrown) {
                    $("#addLotModal_" + idCommand).hide();
                    $("#messageError").removeClass('d-none');
                    $("#messageError").fadeOut(1000);

                }
            });
        }
    });

    $('body').on('click', '.regenerate_lots', function () {

        var idDomForSplit = $(this).attr('id').split("_");
        var idLot = idDomForSplit[idDomForSplit.length - 2];
        var idCommand = idDomForSplit[idDomForSplit.length - 1];

        var domId = idLot + '_' + idCommand;

        model = [];
        label = [];
        indicedebut = [];
        nbtapes = [];
        service = [];
        librairie = [];
        prix = [];
        commentaire = [];
        formInValid = 0;
        commande = [];
        allTapes = [];

        prepareLotCollection(domId, idCommand);

        var totalTapes = 0;

        for(j = 0; j < allTapes.length; j++)
        {
            totalTapes += Number(allTapes[j]);
        }

        var verif = totalTapes - $('#nbtapesMax_' + domId).val();

        if (verif != 0){
            $('#MessageNbTapes_' + domId).removeClass('d-none');
        }
        else {
            $('#MessageNbTapes_' + domId).addClass('d-none');
        }

        if (formInValid == 0 && verif == 0) {

            $.ajax({
                url: '/regenerateLot',
                type: "POST",
                dataType: "json",
                data: {
                    "idLot": idLot,
                    "commande": commande,
                    "model": model,
                    "label": label,
                    "indicedebut": indicedebut,
                    "nbtapes": nbtapes,
                    "service": service,
                    "librairie": librairie,
                    "prix": prix,
                    "commentaire": commentaire
                },
                async: false,
                success: function (data) {
                    $("#regenerateLotModal_" + idCommand + "_" + idLot).hide();
                    $(".messagedanger").removeClass('d-none');
                    $(".messagedanger").fadeOut(1000);

                    setInterval(function () {
                        location.reload();
                    }, 1000);

                },
                error: function (xhr, textStatus, errorThrown) {
                    $("#regenerateLotModal_" + idCommand + "_" + idLot).hide();
                    $("#messageError").removeClass('d-none');
                    $("#messageError").fadeOut(1000);

                }
            });
        }
    });

    $('#addCommande').click(function () {

        var description = $("#description").val();
        var fournisseur = $("#fournisseur option:selected").val();
        var nbtapes = $("#nbtapes").val();
        var FormInvalid = 0;

        if ($("#description").val().length == 0)
        {
            FormInvalid++;
            $("#description").addClass("is-invalid");
            $("#description").removeClass("is-valid");

        }
        else
        {
            $("#description").addClass("is-valid");
            $("#description").removeClass("is-invalid");

        }

        if ($("#nbtapes").val().length == 0)
        {
            FormInvalid++;
            $("#nbtapes").addClass("is-invalid");
            $("#nbtapes").removeClass("is-valid");

        }
        else {
            $("#nbtapes").addClass("is-valid");
            $("#nbtapes").removeClass("is-invalid");
        }

        if (FormInvalid == 0) {
            $.ajax({
                url: '/addCommande',
                type: "POST",
                dataType: "json",
                data: {
                    "description": description,
                    "fournisseur": fournisseur,
                    "nbtapes": nbtapes
                },
                async: false,
                success: function (data) {
                    $("#addCommandeModal").hide();
                    $(".messagedanger").removeClass('d-none');
                    $(".messagedanger").fadeOut(2000);

                    setInterval(function () {
                        location.reload();
                    }, 2000);


                },
                error: function (xhr, textStatus, errorThrown) {
                    $("#addCommandeModal").hide();
                    $("#messageError").removeClass('d-none');
                    $("#messageError").fadeOut(2000);

                }
            });
        }
    });

    $('body').on('click', '.removeCommande', function () {

        var id = $(this).data('id');

        $.ajax({
            url: '/removeCommande',
            type: "POST",
            dataType: "json",
            data: {
                "id": id
            },
            async: false,
            success: function (data) {
                $(".messageSuccess").removeClass('d-none');
                $(".messageSuccess").fadeOut(5000);

                setInterval(function () {
                    location.reload();
                }, 5000);
            },
            error: function (xhr, textStatus, errorThrown) {

                $("#messageError").removeClass('d-none');
                $("#messageError").fadeOut(5000);

            }
        });
    });
});

function prepareLotCollection(domId, idCommand) {

    if ($("#model_" + domId).val().length == 0)
    {
        formInValid++;
        $("#model_" + domId).addClass("is-invalid");
        $("#model_" + domId).removeClass("is-valid");
    }
    else
    {
        $("#model_" + domId).addClass("is-valid");
        $("#model_" + domId).removeClass("is-invalid");
    }

    if ($("#labeltext_" + domId).val().length == 0)
    {
        formInValid++;
        $("#labeltext_" + domId).addClass("is-invalid");
        $("#labeltext_" + domId).removeClass("is-valid");
    }
    else
    {
        $("#labeltext_" + domId).addClass("is-valid");
        $("#labeltext_" + domId).removeClass("is-invalid");
    }

    if ($("#indicedebut_" + domId).val().length == 0)
    {
        formInValid++;
        $("#indicedebut_" + domId).addClass("is-invalid");
        $("#indicedebut_" + domId).removeClass("is-valid");
    }
    else
    {
        $("#indicedebut_" + domId).addClass("is-valid");
        $("#indicedebut_" + domId).removeClass("is-invalid");
    }

    if ($("#nbtapes_" + domId).val().length == 0)
    {
        formInValid++;
        $("#nbtapes_" + domId).addClass("is-invalid");
        $("#nbtapes_" + domId).removeClass("is-valid");
    }
    else
    {
        allTapes.push($("#nbtapes_" + domId).val());
        $("#nbtapes_" + domId).addClass("is-valid");
        $("#nbtapes_" + domId).removeClass("is-invalid");
    }

    if ($("#prix_" + domId).val().length == 0)
    {
        formInValid++;
        $("#prix_" + domId).addClass("is-invalid");
        $("#prix_" + domId).removeClass("is-valid");
    }
    else
    {
        $("#prix_" + domId).addClass("is-valid");
        $("#prix_" + domId).removeClass("is-invalid");
    }

    model.push($("#model_" + domId).val());
    label.push($("#labeltext_" + domId).val());
    indicedebut.push($("#indicedebut_" + domId).val());

    nbtapes.push($("#nbtapes_" + domId).val());
    service.push($('#service_' + domId).val());
    librairie.push($('#librairie_' + domId).val());

    prix.push($('#prix_' + domId).val());
    commentaire.push($('#commentaire_'+ domId).val());

    commande.push(idCommand);
}
