$(document).ready(function () {

    $('#tableLibraries').DataTable({
        'columnDefs': [ {
            'targets': [5], // column index (start from 0)
            'orderable': false, // set orderable false for selected columns
        }]
    });

    $('#addLibrary').click(function () {

        var nom = $("#nom").val();
        var type = $("#type").val();
        var fabricant = $("#fabricant").val();
        var nbslots = $("#nbslots").val();
        var formValid = 0;


        if (nbslots.length == 0)
            nbslots = 0;

        if (nom.length == 0) {
            formValid++;
            $('#nom').addClass("is-invalid");
        } else
            $('#nom').addClass("is-valid");

        if (type.length == 0) {
            formValid++;
            $('#type').addClass("is-invalid");
        } else
            $('#type').addClass("is-valid");

        if (fabricant.length == 0) {
            formValid++;
            $('#fabricant').addClass("is-invalid");
        } else
            $('#fabricant').addClass("is-valid");

        if (formValid == 0) {
            $.ajax({
                url: '/addLibrary',
                type: "POST",
                dataType: "json",
                data: {
                    "nom": nom,
                    "fabricant": fabricant,
                    "type": type,
                    "nbslots": nbslots
                },
                async: false,
                success: function (data) {
                    $("#addModal").hide();
                    $(".messageSuccess").removeClass('d-none');
                    $(".messageSuccess").fadeOut(5000);

                    setInterval(function () {
                        location.reload();
                    }, 5000);


                },
                error: function (xhr, textStatus, errorThrown) {
                    $("#addModal").hide();
                    $("#messageError").removeClass('d-none');
                    $("#messageError").fadeOut(5000);

                }
            });
        }
    });

    $('.editLibrary').click(function () {

        var id = $(this).attr('id').split("edit_").pop();
        var nom = $("#nom_" + id).val();
        var type = $("#type_" + id).val();
        var fabricant = $("#fabricant_" + id).val();
        var nbslots = $("#nbslots_" + id).val();


        $.ajax({
            url: '/editLibrary',
            type: "POST",
            dataType: "json",
            data: {
                "id": id,
                "nom": nom,
                "fabricant": fabricant,
                "type": type,
                "nbslots": nbslots
            },
            async: false,
            success: function (data) {
                $("#editModal_" + id).hide();
                $(".messageSuccess").removeClass('d-none');
                $(".messageSuccess").fadeOut(5000);

                setInterval(function () {
                    location.reload();
                }, 5000);


            },
            error: function (xhr, textStatus, errorThrown) {

                $("#messageError").removeClass('d-none');
                $("#messageError").fadeOut(5000);

            }
        });
    });
    $('.removeLibrary').click(function () {
        var id = $(this).attr('id').split("remove_").pop();

        $.ajax({
            url: '/removeLibrary',
            type: "POST",
            dataType: "json",
            data: {
                "id": id
            },
            async: false,
            success: function (data) {
                $(".messageSuccess").removeClass('d-none');
                $(".messageSuccess").fadeOut(5000);

                setInterval(function () {
                    location.reload();
                }, 5000);


            },
            error: function (xhr, textStatus, errorThrown) {

                $("#messageError").removeClass('d-none');
                $("#messageError").fadeOut(5000);

            }
        });
    });

});