$(document).ready(function () {

    $('#tableModels').DataTable({
        'columnDefs': [ {
            'targets': [4], // column index (start from 0)
            'orderable': false, // set orderable false for selected columns
        }]
    });

    $('#addModel').click(function () {

        var nom = $("#nom").val();
        var capacite = $("#capacite").val();
        var fabricant = $("#fabricant").val();
        var longueur = $("#longueur").val();
        var formInvalid = 0;

        if (longueur.length == 0)
            longueur = 0;

        if (nom.length == 0) {
            formInvalid++;
            $('#nom').addClass("is-invalid");
        } else
            $('#nom').addClass("is-valid");

        if (fabricant.length == 0) {
            formInvalid++;
            $('#fabricant').addClass("is-invalid");
        } else
            $('#fabricant').addClass("is-valid");

        if (capacite.length == 0) {
            formInvalid++;
            $('#capacite').addClass("is-invalid");
        } else
            $('#capacite').addClass("is-valid");


        if (formInvalid == 0) {
            $.ajax({
                url: '/addModel',
                type: "POST",
                dataType: "json",
                data: {
                    "nom": nom,
                    "fabricant": fabricant,
                    "capacite": capacite,
                    "longueur": longueur
                },

                success: function (data) {
                    $("#addModal").hide();
                    $(".messageSuccess").removeClass('d-none');
                    $(".messageSuccess").fadeOut(5000);

                    setInterval(function () {
                        location.reload();
                    }, 5000);


                },
                error: function (xhr, textStatus, errorThrown) {

                    $("#messageError").removeClass('d-none');
                    $("#messageError").fadeOut(5000);

                }
            });
        }

    });

    $('.editModel').click(function () {


        var id = $(this).attr('id').split("edit_").pop();
        var nom = $("#nom_" + id).val();
        var capacite = $("#capacite_" + id).val();
        var fabricant = $("#fabricant_" + id).val();
        var longueur = $("#longueur_" + id).val();


        $.ajax({
            url: '/editModel',
            type: "POST",
            dataType: "json",
            data: {
                "id": id,
                "nom": nom,
                "fabricant": fabricant,
                "capacite": capacite,
                "longueur": longueur
            },
            async: false,
            success: function (data) {
                $("#editModal_" + id).hide();
                $(".messageSuccess").removeClass('d-none');
                $(".messageSuccess").fadeOut(5000);

                setInterval(function () {
                    location.reload();
                }, 5000);


            },
            error: function (xhr, textStatus, errorThrown) {

                $("#messageError").removeClass('d-none');
                $("#messageError").fadeOut(5000);

            }
        });
    });

    $('.removeModel').click(function () {

        var id = $(this).attr('id').split("remove_").pop();
        console.log('id' + id);

        $.ajax({
            url: '/removeModel',
            type: "POST",
            dataType: "json",
            data: {
                "id": id
            },
            async: false,
            success: function (data) {
                $(".messageSuccess").removeClass('d-none');
                $(".messageSuccess").fadeOut(5000);

                setInterval(function () {
                    location.reload();
                }, 5000);


            },
            error: function (xhr, textStatus, errorThrown) {

                $("#messageError").removeClass('d-none');
                $("#messageError").fadeOut(5000);

            }
        });
    });

});