<?php


namespace App\Controller;
use App\Entity\Fournisseur;
use App\Entity\Librairie;
use App\Entity\Lot;
use App\Entity\Service;
use App\Entity\Statut;
use App\Entity\Tape;
use App\Entity\TapeModele;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use App\Entity\Commande;

class CommandeController extends AbstractController
{
    /**
     * @Route("/listCommandes",name="show_commandes")
     */
    public function listCommandes(Request $request)
    {
       
        $Commandes = $this->getDoctrine()
            ->getRepository(Commande::class)
            ->findAll();

        $fournisseurs= $this->getDoctrine()
                ->getRepository(Fournisseur::class)
                ->findAll();

        $models= $this->getDoctrine()
            ->getRepository(TapeModele::class)
            ->findAll();

        $tapes = $this->getDoctrine()
            ->getRepository(Tape::class)
            ->findBoundariesIndexedByLot();

        $services= $this->getDoctrine()
            ->getRepository(Service::class)
            ->findAll();

        $librairies=$this->getDoctrine()
            ->getRepository(Librairie::class)
            ->findAll();

        return $this->render('commandes/main.html.twig', array('Commandes' => $Commandes, 'Fournisseurs'=>$fournisseurs, 'Models'=>$models, 'Bandes' => $tapes, 'Librairies'=>$librairies, 'Services'=>$services));


    }

    /**
     * @Route("/addCommande", name="add_Commande")
     */
    public function addCommande(Request $request)
    {

        $entityManager = $this->getDoctrine()->getManager();

        // Données relatives à la commande
        $description = $request->request->get('description');
        $fournisseurId = $request->request->get('fournisseur');
        $nbtapes = $request->request->get('nbtapes');
        $fournisseur = $this->getDoctrine()->getRepository(Fournisseur::class)->find($fournisseurId);

        /** @var TYPE_NAME $exception */
        try {

            $Commande=new Commande();

        /* Creation de la commande */
        $Commande->setDescription($description);
        $Commande->setFournisseurid($fournisseur);
        $Commande->setNbtapes($nbtapes);
        $Commande->setDatecreation(new \DateTime("now"));
        $entityManager->persist($Commande);
            $entityManager->flush();
            $entityManager->clear();


            $response = new Response(json_encode(array(
                'status' => '200',
                'message' => 'Base de données mise à jour'
            )));

        }
        catch (DBALException $e) {

            $response = new Response(json_encode(array(
                'status' => '500',
                'message' => $e
            )));
        }

        $response = new Response(json_encode(array(
            'status' => '200',
            'message' => 'Base de données mise à jour'
        )));
        $response->headers->set('Content-Type', 'application/json');
        return $response;


    }

    /**
     * @Route("/editCommande", name="edit_Commande")
     */
    public function editCommande(Request $request){

        $id=$request->request->get('id');
        $nom=$request->request->get('nom');
        $fabricant=$request->request->get('fabricant');
        $capacite=$request->request->get('capacite');
        $longueur=$request->request->get('longueur');



        /** @var TYPE_NAME $exception */
        try {

            $id=$request->request->get('id');
            $em = $this->getDoctrine()->getManager();

            $Commande=$this->getDoctrine()
                ->getRepository(TapeCommande::class)->find($id);
            $Commande->setNom($nom);
            $Commande->setFabricant($fabricant);
            $Commande->setCapacite($capacite);
            $Commande->setLongueur($longueur);

            $em->persist($Commande);
            $em->flush();

            $response = new Response(json_encode(array(
                'status' => '200',
                'message' => 'Base de données mise à jour'
            )));

        }
        catch (DBALException $e) {

            $response = new Response(json_encode(array(
                'status' => '500',
                'message' => $e
            )));
        }


        $response->headers->set('Content-Type', 'application/json');
        return $response;

    }

    /**
     * @Route("/removeCommande", name="remove_Commande")
     */
    public function removeCommande(Request $request){

        $id = $request->request->get('id');
        $em = $this->getDoctrine()->getManager();

        /** @var TYPE_NAME $exception */
        try {
            $Commande = $this->getDoctrine()->getRepository(Commande::class)->find($id);

            $Lots = $this->getDoctrine()->getRepository(Lot::class)->findBy(['commandeid' => $Commande->getCommandeid()]);

            $tapeRepository = $this->getDoctrine() ->getRepository(Tape::class);

            foreach($Lots as $lot) {

                $tapes = $tapeRepository->findBy(['lotid' => $lot->getLotid()]);

                foreach($tapes as $tape) {
                    $em->remove($tape);
                }
                $em->flush();

                $em->remove($lot);

            }
            $em->flush();

            $em->remove($Commande);
            $em->flush();

            $response = new Response(json_encode(array(
                'status' => '200',
                'message' => 'Base de données mise à jour'
            )));

        }
        catch (DBALException $e) {

            $response = new Response(json_encode(array(
                'status' => '500',
                'message' => $e
            )));
        }


        $response->headers->set('Content-Type', 'application/json');
        return $response;

    }

}