<?php

namespace App\Controller;

use App\Entity\Commande;
use App\Entity\Librairie;
use App\Entity\Service;
use App\Entity\Statut;
use App\Entity\Tape;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\Annotation\Route;


class DefaultController extends AbstractController
{

    /**
     * @Route("/")
     */
    public function homePage()
    {

        $repositoryTape = $this->getDoctrine()->getRepository(Tape::class);
        $tapes=$repositoryTape->findAll();
        $countTapes = count($tapes);


        $repositoryLibrairie = $this->getDoctrine()->getRepository(Librairie::class);
        $countLibrairies = count($repositoryLibrairie->findAll());

        $repositoryCommande= $this->getDoctrine()->getRepository(Commande::class);
        $countCommandes = count($repositoryCommande->findAll());

        $distributionService=array();
        $distributionStatuts=array();
        $distributionModels=array();

        foreach ($tapes as $tape) {
            if (isset( $distributionService[$tape->getServiceId()->getNom()]))
                $distributionService[$tape->getServiceId()->getNom()]++;
            else
                $distributionService[$tape->getServiceId()->getNom()]=1;

            if (isset(  $distributionStatuts[$tape->getStatutId()->getStatut()]))
                $distributionStatuts[$tape->getStatutId()->getStatut()]++;
            else
                $distributionStatuts[$tape->getStatutId()->getStatut()]=1;

            if (isset(  $distributionModels[$tape->getModeleId()->getNom()]))
                $distributionModels[$tape->getModeleId()->getNom()]++;
            else
                $distributionModels[$tape->getModeleId()->getNom()]=1;

        }



        return $this->render('default/home.html.twig',
            array('nbtapes'=>$countTapes,'nblibrairies'=>$countLibrairies,'nbcommandes'=>$countCommandes,
                'distributionStatuts'=>$distributionStatuts,'distributionService'=>$distributionService,'distributionModels'=>$distributionModels));
    }
}