<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;

/**
 * Commande
 *
 * @ORM\Table(name="commande", indexes={@ORM\Index(name="ref_fournisseur", columns={"FournisseurID"})})
 * @ORM\Entity
 */
class Commande
{
    /**
     * @var int
     *
     * @ORM\Column(name="CommandeID", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $commandeid;

    /**
     * @var string
     *
     * @ORM\Column(name="Description", type="string", length=255, nullable=false)
     */
    private $description;

    /**
     * @var int
     *
     * @ORM\Column(name="Nbtapes", type="integer", nullable=false)
     */
    private $nbtapes = '0';

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="DateCreation", type="datetime", nullable=false)
     */
    private $datecreation;

    /**
     * @var \Fournisseur
     *
     * @ORM\ManyToOne(targetEntity="Fournisseur")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="FournisseurID", referencedColumnName="FournisseurID")
     * })
     */
    private $fournisseurid;

    /**
     * @ORM\OneToMany(targetEntity=Lot::class, mappedBy="commandeid")
     */
    private $lots;

    public function getCommandeid(): ?int
    {
        return $this->commandeid;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    public function getNbtapes(): ?int
    {
        return $this->nbtapes;
    }

    public function setNbtapes(int $nbtapes): self
    {
        $this->nbtapes = $nbtapes;

        return $this;
    }

    public function getDatecreation(): ?\DateTimeInterface
    {
        return $this->datecreation;
    }

    public function setDatecreation(\DateTimeInterface $datecreation): self
    {
        $this->datecreation = $datecreation;

        return $this;
    }

    public function getFournisseurid(): ?Fournisseur
    {
        return $this->fournisseurid;
    }

    public function setFournisseurid(?Fournisseur $fournisseurid): self
    {
        $this->fournisseurid = $fournisseurid;

        return $this;
    }

    /**
     * @return Collection|Lot[]
     */
    public function getLots(): Collection
    {
        return $this->lots;
    }
}
