<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Lot
 *
 * @ORM\Table(name="lot", indexes={@ORM\Index(name="ref_statut_lot", columns={"StatutID"}), @ORM\Index(name="ref_commande", columns={"CommandeID"}), @ORM\Index(name="ref_modelTape", columns={"TapesModeleID"})})
 * @ORM\Entity
 */
class Lot
{
    /**
     * @var int
     *
     * @ORM\Column(name="LotID", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $lotid;

    /**
     * @var int
     *
     * @ORM\Column(name="TapesNb", type="integer", nullable=false)
     */
    private $tapesnb;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="DateCreation", type="datetime", nullable=false)
     */
    private $datecreation;

    /**
     * @var \DateTime|null
     *
     * @ORM\Column(name="DateMiseService", type="datetime", nullable=true)
     */
    private $datemiseservice;

    /**
     * @var \DateTime|null
     *
     * @ORM\Column(name="DateLivraison", type="datetime", nullable=true)
     */
    private $datelivraison;

    /**
     * @var \Commande
     *
     * @ORM\ManyToOne(targetEntity=Commande::class, inversedBy="lots")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="CommandeID", referencedColumnName="CommandeID")
     * })
     */
    private $commandeid;

    /**
     * @var \TapeModele
     *
     * @ORM\ManyToOne(targetEntity="TapeModele")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="TapesModeleID", referencedColumnName="ModelID")
     * })
     */
    private $tapesmodeleid;

    /**
     * @var \Statut
     *
     * @ORM\ManyToOne(targetEntity="Statut")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="StatutID", referencedColumnName="StatutID")
     * })
     */
    private $statutid;

    public function getLotid(): ?int
    {
        return $this->lotid;
    }

    public function getTapesnb(): ?int
    {
        return $this->tapesnb;
    }

    public function setTapesnb(int $tapesnb): self
    {
        $this->tapesnb = $tapesnb;

        return $this;
    }

    public function getDatecreation(): ?\DateTimeInterface
    {
        return $this->datecreation;
    }

    public function setDatecreation(\DateTimeInterface $datecreation): self
    {
        $this->datecreation = $datecreation;

        return $this;
    }

    public function getDatemiseservice(): ?\DateTimeInterface
    {
        return $this->datemiseservice;
    }

    public function setDatemiseservice(?\DateTimeInterface $datemiseservice): self
    {
        $this->datemiseservice = $datemiseservice;

        return $this;
    }

    public function getDatelivraison(): ?\DateTimeInterface
    {
        return $this->datelivraison;
    }

    public function setDatelivraison(?\DateTimeInterface $datelivraison): self
    {
        $this->datelivraison = $datelivraison;

        return $this;
    }

    public function getCommandeid(): ?Commande
    {
        return $this->commandeid;
    }

    public function setCommandeid(?Commande $commandeid): self
    {
        $this->commandeid = $commandeid;

        return $this;
    }

    public function getTapesmodeleid(): ?TapeModele
    {
        return $this->tapesmodeleid;
    }

    public function setTapesmodeleid(?TapeModele $tapesmodeleid): self
    {
        $this->tapesmodeleid = $tapesmodeleid;

        return $this;
    }

    public function getStatutid(): ?Statut
    {
        return $this->statutid;
    }

    public function setStatutid(?Statut $statutid): self
    {
        $this->statutid = $statutid;

        return $this;
    }


}
