<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;
use JMS\Serializer\Annotation as Serializer;

/**
 * TapeModele
 *
 * @ORM\Table(name="tape_modele")
 * @ORM\Entity
 *
 * @Serializer\ExclusionPolicy("ALL")
 */
class TapeModele
{
    /**
     * @var int
     *
     * @ORM\Column(name="ModelID", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     * @Serializer\Expose()
     */
    private $modelid;

    /**
     * @var string
     *
     * @ORM\Column(name="Nom", type="string", length=255, nullable=false)
     * @Serializer\Expose()
     */
    private $nom;

    /**
     * @var string
     *
     * @ORM\Column(name="Fabricant", type="string", length=255, nullable=false)
     */
    private $fabricant;

    /**
     * @var float|null
     *
     * @ORM\Column(name="Capacite", type="float", precision=10, scale=0, nullable=true)
     */
    private $capacite;

    /**
     * @var float|null
     *
     * @ORM\Column(name="Longueur", type="float", precision=10, scale=0, nullable=true)
     */
    private $longueur = '0';

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="DateCreation", type="datetime", nullable=false)
     */
    private $datecreation;

    public function getModelid(): ?int
    {
        return $this->modelid;
    }

    public function getNom(): ?string
    {
        return $this->nom;
    }

    public function setNom(string $nom): self
    {
        $this->nom = $nom;

        return $this;
    }

    public function getFabricant(): ?string
    {
        return $this->fabricant;
    }

    public function setFabricant(string $fabricant): self
    {
        $this->fabricant = $fabricant;

        return $this;
    }

    public function getCapacite(): ?float
    {
        return $this->capacite;
    }

    public function setCapacite(?float $capacite): self
    {
        $this->capacite = $capacite;

        return $this;
    }

    public function getLongueur(): ?float
    {
        return $this->longueur;
    }

    public function setLongueur(?float $longueur): self
    {
        $this->longueur = $longueur;

        return $this;
    }

    public function getDatecreation(): ?\DateTimeInterface
    {
        return $this->datecreation;
    }

    public function setDatecreation(\DateTimeInterface $datecreation): self
    {
        $this->datecreation = $datecreation;

        return $this;
    }


}
