<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * TapesHistory
 *
 * @ORM\Table(name="tapes_history", indexes={@ORM\Index(name="ref_tape", columns={"TapeID"})})
 * @ORM\Entity
 */
class TapesHistory
{
    /**
     * @var int
     *
     * @ORM\Column(name="HistoryID", type="integer", nullable=false)
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $historyid;

    /**
     * @var int
     *
     * @ORM\Column(name="StatutID", type="integer", nullable=false)
     */
    private $statutid;

    /**
     * @var \DateTime
     *
     * @ORM\Column(name="DateDebut", type="datetime", nullable=false)
     */
    private $datedebut;

    /**
     * @var \DateTime|null
     *
     * @ORM\Column(name="DateFin", type="datetime", nullable=true)
     */
    private $datefin;

    /**
     * @var \Tape
     *
     * @ORM\ManyToOne(targetEntity="Tape")
     * @ORM\JoinColumns({
     *   @ORM\JoinColumn(name="TapeID", referencedColumnName="TapeID")
     * })
     */
    private $tapeid;

    public function getHistoryid(): ?int
    {
        return $this->historyid;
    }

    public function getStatutid(): ?int
    {
        return $this->statutid;
    }

    public function setStatutid(int $statutid): self
    {
        $this->statutid = $statutid;

        return $this;
    }

    public function getDatedebut(): ?\DateTimeInterface
    {
        return $this->datedebut;
    }

    public function setDatedebut(\DateTimeInterface $datedebut): self
    {
        $this->datedebut = $datedebut;

        return $this;
    }

    public function getDatefin(): ?\DateTimeInterface
    {
        return $this->datefin;
    }

    public function setDatefin(?\DateTimeInterface $datefin): self
    {
        $this->datefin = $datefin;

        return $this;
    }

    public function getTapeid(): ?Tape
    {
        return $this->tapeid;
    }

    public function setTapeid(?Tape $tapeid): self
    {
        $this->tapeid = $tapeid;

        return $this;
    }


}
