<?php

namespace App\Repository;

use App\Entity\Tape;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * @method Tape|null find($id, $lockMode = null, $lockVersion = null)
 * @method Tape|null findOneBy(array $criteria, array $orderBy = null)
 * @method Tape[]    findAll()
 * @method Tape[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class TapeRepository extends ServiceEntityRepository
{
    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Tape::class);
    }

    public function findBoundariesIndexedByLot(){

        $qb = $this->createQueryBuilder('t')
            ->select(['l.lotid, min(t.label) as tapeMin, max(t.label) as tapeMax'])
            ->join('t.lotid', 'l', null, null, 'l.lotid')
            ->groupBy('l.lotid');

        $query = $qb->getQuery();

        return $query->getResult();
    }

}
