<?php

namespace App\Services;

use App\Entity\Commande;
use App\Entity\Downtime\Communication;
use App\Entity\Downtime\EmailStatus;
use App\Entity\Lot;
use App\Entity\Statut;
use App\Entity\TapeModele;
use Doctrine\ORM\EntityManagerInterface;
use Doctrine\Persistence\ManagerRegistry;
use Symfony\Component\DependencyInjection\ContainerInterface;
use App\Services\Mailer;

class LotService
{
    public function __construct(ManagerRegistry $doctrine)
    {
        $this->doctrine = $doctrine;
    }

    public function create($commandeId, $modeleId, $statut, $nbTapes)
    {
        $Lot = new Lot();

        /*Creation des lots */

        $commande = $this->doctrine->getRepository(Commande::class)->find($commandeId);
        $Lot->setCommandeid($commande);

        $tapemodel = $this->doctrine->getRepository(TapeModele::class)->find($modeleId);
        $Lot->setTapesmodeleid($tapemodel);

        $dateCreation = new \DateTime("now");
        $Lot->setDatecreation($dateCreation);

        $Lot->setTapesnb($nbTapes);

        $Lot->setStatutid($statut);

        return $Lot;
    }
}